
package com.vmware.vim;

import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlType;


/**
 * <p>Java class for HostConfigInfo complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType name="HostConfigInfo">
 *   &lt;complexContent>
 *     &lt;extension base="{urn:vim2}DynamicData">
 *       &lt;sequence>
 *         &lt;element name="host" type="{urn:vim2}ManagedObjectReference"/>
 *         &lt;element name="product" type="{urn:vim2}AboutInfo"/>
 *         &lt;element name="hyperThread" type="{urn:vim2}HostHyperThreadScheduleInfo" minOccurs="0"/>
 *         &lt;element name="consoleReservation" type="{urn:vim2}ServiceConsoleReservationInfo" minOccurs="0"/>
 *         &lt;element name="storageDevice" type="{urn:vim2}HostStorageDeviceInfo" minOccurs="0"/>
 *         &lt;element name="fileSystemVolume" type="{urn:vim2}HostFileSystemVolumeInfo" minOccurs="0"/>
 *         &lt;element name="network" type="{urn:vim2}HostNetworkInfo" minOccurs="0"/>
 *         &lt;element name="vmotion" type="{urn:vim2}HostVMotionInfo" minOccurs="0"/>
 *         &lt;element name="capabilities" type="{urn:vim2}HostNetCapabilities" minOccurs="0"/>
 *         &lt;element name="offloadCapabilities" type="{urn:vim2}HostNetOffloadCapabilities" minOccurs="0"/>
 *         &lt;element name="service" type="{urn:vim2}HostServiceInfo" minOccurs="0"/>
 *         &lt;element name="firewall" type="{urn:vim2}HostFirewallInfo" minOccurs="0"/>
 *         &lt;element name="autoStart" type="{urn:vim2}HostAutoStartManagerConfig" minOccurs="0"/>
 *         &lt;element name="activeDiagnosticPartition" type="{urn:vim2}HostDiagnosticPartition" minOccurs="0"/>
 *         &lt;element name="option" type="{urn:vim2}OptionValue" maxOccurs="unbounded" minOccurs="0"/>
 *         &lt;element name="optionDef" type="{urn:vim2}OptionDef" maxOccurs="unbounded" minOccurs="0"/>
 *         &lt;element name="datastorePrincipal" type="{http://www.w3.org/2001/XMLSchema}string" minOccurs="0"/>
 *         &lt;element name="systemResources" type="{urn:vim2}HostSystemResourceInfo" minOccurs="0"/>
 *       &lt;/sequence>
 *     &lt;/extension>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "HostConfigInfo", propOrder = {
    "host",
    "product",
    "hyperThread",
    "consoleReservation",
    "storageDevice",
    "fileSystemVolume",
    "network",
    "vmotion",
    "capabilities",
    "offloadCapabilities",
    "service",
    "firewall",
    "autoStart",
    "activeDiagnosticPartition",
    "option",
    "optionDef",
    "datastorePrincipal",
    "systemResources"
})
public class HostConfigInfo
    extends DynamicData
{

    @XmlElement(required = true)
    protected ManagedObjectReference host;
    @XmlElement(required = true)
    protected AboutInfo product;
    protected HostHyperThreadScheduleInfo hyperThread;
    protected ServiceConsoleReservationInfo consoleReservation;
    protected HostStorageDeviceInfo storageDevice;
    protected HostFileSystemVolumeInfo fileSystemVolume;
    protected HostNetworkInfo network;
    protected HostVMotionInfo vmotion;
    protected HostNetCapabilities capabilities;
    protected HostNetOffloadCapabilities offloadCapabilities;
    protected HostServiceInfo service;
    protected HostFirewallInfo firewall;
    protected HostAutoStartManagerConfig autoStart;
    protected HostDiagnosticPartition activeDiagnosticPartition;
    protected List<OptionValue> option;
    protected List<OptionDef> optionDef;
    protected String datastorePrincipal;
    protected HostSystemResourceInfo systemResources;

    /**
     * Gets the value of the host property.
     * 
     * @return
     *     possible object is
     *     {@link ManagedObjectReference }
     *     
     */
    public ManagedObjectReference getHost() {
        return host;
    }

    /**
     * Sets the value of the host property.
     * 
     * @param value
     *     allowed object is
     *     {@link ManagedObjectReference }
     *     
     */
    public void setHost(ManagedObjectReference value) {
        this.host = value;
    }

    /**
     * Gets the value of the product property.
     * 
     * @return
     *     possible object is
     *     {@link AboutInfo }
     *     
     */
    public AboutInfo getProduct() {
        return product;
    }

    /**
     * Sets the value of the product property.
     * 
     * @param value
     *     allowed object is
     *     {@link AboutInfo }
     *     
     */
    public void setProduct(AboutInfo value) {
        this.product = value;
    }

    /**
     * Gets the value of the hyperThread property.
     * 
     * @return
     *     possible object is
     *     {@link HostHyperThreadScheduleInfo }
     *     
     */
    public HostHyperThreadScheduleInfo getHyperThread() {
        return hyperThread;
    }

    /**
     * Sets the value of the hyperThread property.
     * 
     * @param value
     *     allowed object is
     *     {@link HostHyperThreadScheduleInfo }
     *     
     */
    public void setHyperThread(HostHyperThreadScheduleInfo value) {
        this.hyperThread = value;
    }

    /**
     * Gets the value of the consoleReservation property.
     * 
     * @return
     *     possible object is
     *     {@link ServiceConsoleReservationInfo }
     *     
     */
    public ServiceConsoleReservationInfo getConsoleReservation() {
        return consoleReservation;
    }

    /**
     * Sets the value of the consoleReservation property.
     * 
     * @param value
     *     allowed object is
     *     {@link ServiceConsoleReservationInfo }
     *     
     */
    public void setConsoleReservation(ServiceConsoleReservationInfo value) {
        this.consoleReservation = value;
    }

    /**
     * Gets the value of the storageDevice property.
     * 
     * @return
     *     possible object is
     *     {@link HostStorageDeviceInfo }
     *     
     */
    public HostStorageDeviceInfo getStorageDevice() {
        return storageDevice;
    }

    /**
     * Sets the value of the storageDevice property.
     * 
     * @param value
     *     allowed object is
     *     {@link HostStorageDeviceInfo }
     *     
     */
    public void setStorageDevice(HostStorageDeviceInfo value) {
        this.storageDevice = value;
    }

    /**
     * Gets the value of the fileSystemVolume property.
     * 
     * @return
     *     possible object is
     *     {@link HostFileSystemVolumeInfo }
     *     
     */
    public HostFileSystemVolumeInfo getFileSystemVolume() {
        return fileSystemVolume;
    }

    /**
     * Sets the value of the fileSystemVolume property.
     * 
     * @param value
     *     allowed object is
     *     {@link HostFileSystemVolumeInfo }
     *     
     */
    public void setFileSystemVolume(HostFileSystemVolumeInfo value) {
        this.fileSystemVolume = value;
    }

    /**
     * Gets the value of the network property.
     * 
     * @return
     *     possible object is
     *     {@link HostNetworkInfo }
     *     
     */
    public HostNetworkInfo getNetwork() {
        return network;
    }

    /**
     * Sets the value of the network property.
     * 
     * @param value
     *     allowed object is
     *     {@link HostNetworkInfo }
     *     
     */
    public void setNetwork(HostNetworkInfo value) {
        this.network = value;
    }

    /**
     * Gets the value of the vmotion property.
     * 
     * @return
     *     possible object is
     *     {@link HostVMotionInfo }
     *     
     */
    public HostVMotionInfo getVmotion() {
        return vmotion;
    }

    /**
     * Sets the value of the vmotion property.
     * 
     * @param value
     *     allowed object is
     *     {@link HostVMotionInfo }
     *     
     */
    public void setVmotion(HostVMotionInfo value) {
        this.vmotion = value;
    }

    /**
     * Gets the value of the capabilities property.
     * 
     * @return
     *     possible object is
     *     {@link HostNetCapabilities }
     *     
     */
    public HostNetCapabilities getCapabilities() {
        return capabilities;
    }

    /**
     * Sets the value of the capabilities property.
     * 
     * @param value
     *     allowed object is
     *     {@link HostNetCapabilities }
     *     
     */
    public void setCapabilities(HostNetCapabilities value) {
        this.capabilities = value;
    }

    /**
     * Gets the value of the offloadCapabilities property.
     * 
     * @return
     *     possible object is
     *     {@link HostNetOffloadCapabilities }
     *     
     */
    public HostNetOffloadCapabilities getOffloadCapabilities() {
        return offloadCapabilities;
    }

    /**
     * Sets the value of the offloadCapabilities property.
     * 
     * @param value
     *     allowed object is
     *     {@link HostNetOffloadCapabilities }
     *     
     */
    public void setOffloadCapabilities(HostNetOffloadCapabilities value) {
        this.offloadCapabilities = value;
    }

    /**
     * Gets the value of the service property.
     * 
     * @return
     *     possible object is
     *     {@link HostServiceInfo }
     *     
     */
    public HostServiceInfo getService() {
        return service;
    }

    /**
     * Sets the value of the service property.
     * 
     * @param value
     *     allowed object is
     *     {@link HostServiceInfo }
     *     
     */
    public void setService(HostServiceInfo value) {
        this.service = value;
    }

    /**
     * Gets the value of the firewall property.
     * 
     * @return
     *     possible object is
     *     {@link HostFirewallInfo }
     *     
     */
    public HostFirewallInfo getFirewall() {
        return firewall;
    }

    /**
     * Sets the value of the firewall property.
     * 
     * @param value
     *     allowed object is
     *     {@link HostFirewallInfo }
     *     
     */
    public void setFirewall(HostFirewallInfo value) {
        this.firewall = value;
    }

    /**
     * Gets the value of the autoStart property.
     * 
     * @return
     *     possible object is
     *     {@link HostAutoStartManagerConfig }
     *     
     */
    public HostAutoStartManagerConfig getAutoStart() {
        return autoStart;
    }

    /**
     * Sets the value of the autoStart property.
     * 
     * @param value
     *     allowed object is
     *     {@link HostAutoStartManagerConfig }
     *     
     */
    public void setAutoStart(HostAutoStartManagerConfig value) {
        this.autoStart = value;
    }

    /**
     * Gets the value of the activeDiagnosticPartition property.
     * 
     * @return
     *     possible object is
     *     {@link HostDiagnosticPartition }
     *     
     */
    public HostDiagnosticPartition getActiveDiagnosticPartition() {
        return activeDiagnosticPartition;
    }

    /**
     * Sets the value of the activeDiagnosticPartition property.
     * 
     * @param value
     *     allowed object is
     *     {@link HostDiagnosticPartition }
     *     
     */
    public void setActiveDiagnosticPartition(HostDiagnosticPartition value) {
        this.activeDiagnosticPartition = value;
    }

    /**
     * Gets the value of the option property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the option property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getOption().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link OptionValue }
     * 
     * 
     */
    public List<OptionValue> getOption() {
        if (option == null) {
            option = new ArrayList<OptionValue>();
        }
        return this.option;
    }

    /**
     * Gets the value of the optionDef property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the optionDef property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getOptionDef().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link OptionDef }
     * 
     * 
     */
    public List<OptionDef> getOptionDef() {
        if (optionDef == null) {
            optionDef = new ArrayList<OptionDef>();
        }
        return this.optionDef;
    }

    /**
     * Gets the value of the datastorePrincipal property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getDatastorePrincipal() {
        return datastorePrincipal;
    }

    /**
     * Sets the value of the datastorePrincipal property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setDatastorePrincipal(String value) {
        this.datastorePrincipal = value;
    }

    /**
     * Gets the value of the systemResources property.
     * 
     * @return
     *     possible object is
     *     {@link HostSystemResourceInfo }
     *     
     */
    public HostSystemResourceInfo getSystemResources() {
        return systemResources;
    }

    /**
     * Sets the value of the systemResources property.
     * 
     * @param value
     *     allowed object is
     *     {@link HostSystemResourceInfo }
     *     
     */
    public void setSystemResources(HostSystemResourceInfo value) {
        this.systemResources = value;
    }

}
